//
//
// NOTE: Serch for "EWSServerName" and replace with your EWS Server Name
//
//


// Service Requests
app.custom.formTasks.add('ServiceRequest', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
		if (session.user.Analyst) { 			
			// Prepare Help Block Auto-Update on Required Fields
			prepHelpBlock("RequestedWorkItem", pageForm.viewModel.RequestedWorkItem);
		}
	}); 
	return;
});

// Incidents
app.custom.formTasks.add('Incident', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
		if (session.user.Analyst) {
			// Prepare Help Block Auto-Update on Required Fields (part of Custom_HelpBlock)
			prepHelpBlock("RequestedWorkItem", pageForm.viewModel.RequestedWorkItem);
		}
	});
	return;
});

/*
	Preps Help-Block for specific User Picker HTML ID / User Picker Object
*/
function prepHelpBlock(userPickerId, userPickerObject) {	
//	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_VIP' class='help-block-credentials'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_IMG' class='help-block-credentials'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Pager' class='help-block-credentials'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Notes' class='help-block'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Title' class='help-block'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Office' class='help-block'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_StreetAddress' class='help-block'></span>");	
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_StreetAddress2' class='help-block'></span>");	
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_BusinessPhone' class='help-block'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Mobile' class='help-block'></span>");	
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Email' class='help-block'></span>");
	$("label[for='" + userPickerId + "']").parent().append("<span id='" + userPickerId + "_Manager' class='help-block'></span>");
	
	if (pageForm.viewModel.RequestedWorkItem.BaseId) {
		updateHelpBlock(userPickerObject.BaseId, userPickerId, false);		
	}
	boundObj[userPickerId].bind("change", function(){ updateHelpBlock(this.BaseId, userPickerId, true); });
		
	$("label[for='" + userPickerId + "']").parent().on("click", "a", function(e)
		{
			var mailLink = e.target.href;
			var irTitle = (pageForm.viewModel.Title) ? encodeURIComponent(pageForm.viewModel.Title) : "";
			var emailSubject = "[" + pageForm.viewModel.Id + "] " + irTitle;
			var irDesc = (pageForm.viewModel.Description) ? encodeURIComponent(pageForm.viewModel.Description) : "";
			e.currentTarget.href = mailLink + "&cc=DPTI.ServiceManagerDev@sa.gov.au&subject=" + emailSubject;
		}
	)
}



/*
	updates Help Block on User Change
*/
function updateHelpBlock (userGUID, userPickerId, onChangeUser) {
	var lookupUserId = (userGUID) ? userGUID : "";
	$.get("/api/V3/User/GetUserRelatedInfoByUserId", { userId: lookupUserId },
	function (data) {
		if (data.length > 0)
		{
			var obj = jQuery.parseJSON( data);
			
			var strPager = "";
			var strNotes = "";
			var strTitle = "";
			var strOffice = "";
			var strStreetAddress = "";					
			var strStreetAddress2 = "";
			var strBusinessPhone = "";
			var strMobile = "";
			var strEmailLink = "";
			var strManager = "";
			var EWSServerName = "Put.Server.Name.Here";
			//---
			if (typeof obj.Email)
			{
				var emailTo = obj.Email;
				var emailCC = "";
				strEmailLink = "<a href='mailto:" + emailTo + "'>" + emailTo + "</a>";
				$("#" + userPickerId + "_Email").html(strEmailLink);
				
				$("#" + userPickerId + "_IMG").html("<img src='https://" + EWSServerName + "/EWS/Exchange.asmx/s/GetUserPhoto?email=" + emailTo + "&size=HR96x96'>");
			}
			else
			{
				$("#" + userPickerId + "_Email").html("");
				$("#" + userPickerId + "_IMG").html("");
			}
			//---
			if (typeof obj.Title)
			{
				strTitle = obj.Title;				
				$("#" + userPickerId + "_Title").html(strTitle);
			}
			else
			{
				$("#" + userPickerId + "_Title").html(""); 
			}
			//---
			if (typeof obj.BusinessPhone && typeof obj.HomePhone && obj.BusinessPhone != null  && obj.HomePhone != null)
			{
				strBusinessPhone = obj.BusinessPhone + " ; " + obj.HomePhone;
				$("#" + userPickerId + "_BusinessPhone").html(strBusinessPhone);
			}
			else
			{
				if (typeof obj.BusinessPhone && obj.BusinessPhone != null)
				{
					strBusinessPhone = obj.BusinessPhone;
					$("#" + userPickerId + "_BusinessPhone").html(strBusinessPhone);
				}
				else
				{
					if (typeof obj.HomePhone  && obj.HomePhone != null)
					{
						strBusinessPhone = obj.HomePhone;
						$("#" + userPickerId + "_BusinessPhone").html(strBusinessPhone);
					}
					else
					{
						$("#" + userPickerId + "_BusinessPhone").html("");
					}
				}
			}
			//---
			if (typeof obj.Office && obj.Office != null)
			{
				strOffice = obj.Office;
				if (strOffice.length > 5 && strOffice.lastIndexOf("\\") != -1) {
					$("#" + userPickerId + "_Office").html(strOffice.substr(strOffice.lastIndexOf("\\") + 1));
				} else {
					$("#" + userPickerId + "_Office").html("");
				}
			}
			else
			{
				$("#" + userPickerId + "_Office").html("");
			}
			//---
			if (typeof obj.StreetAddress)
			{
				strStreetAddress = obj.StreetAddress;
				$("#" + userPickerId + "_StreetAddress").html(strStreetAddress);
			}
			else
			{
				$("#" + userPickerId + "_StreetAddress").html("");
			}
			strStreetAddress2 = "";
			if (typeof obj.City && obj.City != null)
			{
				strStreetAddress2 = strStreetAddress2 + obj.City;
			}
			if (typeof obj.State && obj.State != null)
			{
				strStreetAddress2 = strStreetAddress2 + " " + obj.State;
			}
			if (typeof obj.Zip && obj.Zip != null)
			{
				strStreetAddress2 = strStreetAddress2 + " " + obj.Zip;
			}
			$("#" + userPickerId + "_StreetAddress2").html(strStreetAddress2);
			//---
			if (typeof obj.Mobile && typeof obj.Fax && obj.Mobile != null  && obj.Fax != null)
			{
				strMobile = "Mob: " + obj.Mobile + " ; Fax: " + obj.Fax;
				$("#" + userPickerId + "_Mobile").html(strMobile);
			}
			else
			{
				if (typeof obj.Mobile && obj.Mobile != null)
				{
					strMobile = "Mob: " + obj.Mobile;
					$("#" + userPickerId + "_Mobile").html(strMobile);
				}
				else
				{
					if (typeof obj.Fax  && obj.Fax != null)
					{
						strMobile = "Fax: " + obj.Fax;
						$("#" + userPickerId + "_Mobile").html(strMobile);
					}
					else
					{
						$("#" + userPickerId + "_Mobile").html("");
					}
				}
			}
			//---
			if (typeof obj.Notes)
			{
				strNotes = obj.Notes;
				$("#" + userPickerId + "_Notes").html(strNotes);
			}
			else
			{
				$("#" + userPickerId + "_Notes").html("");
			}
			//---
			if (typeof obj.Manager)
			{
				strManager = obj.Manager;
				$("#" + userPickerId + "_Manager").html(strManager);
			}
			else
			{
				$("#" + userPickerId + "_Notes").html("");
			}
			//---
			if (typeof obj.Pager)
			{
				strPager = obj.Pager;
				$("#" + userPickerId + "_Pager").html(strPager);
				if (userPickerId == "RequestedWorkItem" && window.location.href.indexOf("Incident") > -1) {
					if (strPager != null && strPager.indexOf("VIP") === 0 && onChangeUser) {
						//Set Timestamp for when helpblock was last updated.
						var currentdate = (new Date()).toString();
						if (pageForm.viewModel.HelpBlockLastUpdated != currentdate) {							
							alertify.error('<span id="vipdetected"><p align="center"><b><font size="8"> VIP  User<br> Detected</font></b></p></span>', "", 0);
						}
						pageForm.viewModel.HelpBlockLastUpdated = currentdate;
					}				
				}
			}
			else
			{
				$("#" + userPickerId + "_Pager").html("");
			}			

		}
		else
		{
			$("#" + userPickerId + "_IMG").html("");					
			$("#" + userPickerId + "_Pager").html("");					
			$("#" + userPickerId + "_Notes").html("");					
			$("#" + userPickerId + "_Title").html("");
			$("#" + userPickerId + "_Office").html("");
			$("#" + userPickerId + "_StreetAddress").html("");
			$("#" + userPickerId + "_StreetAddress2").html("");
			$("#" + userPickerId + "_BusinessPhone").html("");
			$("#" + userPickerId + "_Mobile").html("");
			$("#" + userPickerId + "_Email").html("");
			$("#" + userPickerId + "_Manager").html("");
		}
	},"json");			
}

